export class BiMap<A, B> {
	#aToB: Map<A, B> = new Map();
	#bToA: Map<B, A> = new Map();

	set(a: A, b: B) {
		this.#aToB.set(a, b);
		this.#bToA.set(b, a);
	}

	getByA(a: A) {
		return this.#aToB.get(a);
	}

	getByB(b: B) {
		return this.#bToA.get(b);
	}

	removeByA(a: A) {
		const b = this.getByA(a);
		this.#aToB.delete(a);
		this.#bToA.delete(b!);
	}

	removeByB(b: B) {
		const a = this.getByB(b);
		this.#bToA.delete(b);
		this.#aToB.delete(a!);
	}
}
