export type PeerID = string & { readonly __peer_id: unique symbol };

export type Registered = {
	kind: "registered";
	peerID: PeerID;
};
export type ConnectOffer = {
	kind: "connectOffer";
	peerID: PeerID;
	offer: RTCSessionDescriptionInit;
};
export type ConnectReject = {
	kind: "connectReject";
	peerID: PeerID;
};
export type ConnectAnswer = {
	kind: "connectAnswer";
	peerID: PeerID;
	answer: RTCSessionDescriptionInit;
};
export type ICECandidate = {
	kind: "iceCandidate";
	peerID: PeerID;
	candidate: RTCIceCandidateInit;
};
export type PearError = { error: string };

export type PearRequest =
	| ConnectOffer
	| ConnectAnswer
	| ConnectReject
	| ICECandidate;
export type PearResponse =
	| Registered
	| ConnectAnswer
	| ConnectOffer
	| ConnectReject
	| ICECandidate
	| PearError;
